# MNIST-keras example Using IBM Distributed Deep Learning

## About

The `mnist-tf-keras.py` script is a simple example that demonstrates how to modify a TensorFlow-keras script to use IBM Distributed Deep Learning (DDL).

The `mnist-keras.py` script is an example that demonstrates how to run Tensorflow with native Keras and IBM Distributed Deep Learningi(DDL).

## Running MNIST-keras

Before running either of the scripts, make sure there is a conda environment activated with the `ddl-tensorflow` package installed.

The examples should also be copied into a user directory by running the following command:

```bash
$ ddl-tensorflow-install-samples <somedir>
```

Before running the `mnist-keras.py`, make sure there is a conda environment activated with base keras package installed.

```bash
$ conda install keras
```

To run `mnist-keras.py` on two machines named host1 and host2 that each have 4 GPUS:

```bash
$ ddlrun -H host1,host2 python mnist-keras.py
```

To run `mnist-tf-keras.py` on two machines named host1 and host2 that each have 4 GPUs:

```bash
$ ddlrun -H host1,host2 python mnist-tf-keras.py
```

To train the MNIST Keras model in TensorFlow's eager execution:

```bash
$ ddlrun -H host1,host2 python mnist-tf-keras.py --eager
```

&copy; Copyright IBM Corporation 2018, 2019
